##数据处理
rm(list = ls())
library(rms)
library(readr)

data <- read_csv("D:/R work/Model-TC.csv")
data_in <- read_csv("D:/R work/Model-IVC.csv")
data_out <- read_csv("D:/R work/Model-EVC.csv")

data$Diameter_M<-factor(data$Diameter_M,levels = c(1,2,3),labels = c("5mm≤d≤10mm","10mm<d≤20mm","20mm<d≤30mm"))
data$CT.value_M<-factor(data$CT.value_M,levels = c(1,2,3,4),labels = c("-800HU<n≤-600HU","-600HU<n≤-400HU","-400HU<n≤-200HU","n≤-200HU"))
data$CTR_J<-factor(data$CTR_J,levels = c(0,1),labels = c("≤0.265",">0.265"))
data$CEA_J<-factor(data$CEA_J,levels = c(0,1),labels = c("≤1.965ng/ml",">1.965ng/ml"))
data$Outcome<-factor(data$Outcome,levels = c(0,1),labels = c("Not HRPN","HRPN"))

data_in$Diameter_M<-factor(data_in$Diameter_M,levels = c(1,2,3),labels = c("5mm≤d≤10mm","10mm<d≤20mm","20mm<d≤30mm"))
data_in$CT.value_M<-factor(data_in$CT.value_M,levels = c(1,2,3,4),labels = c("-800HU<n≤-600HU","-600HU<n≤-400HU","-400HU<n≤-200HU","n≤-200HU"))
data_in$CTR_J<-factor(data_in$CTR_J,levels = c(0,1),labels = c("≤0.265",">0.265"))
data_in$CEA_J<-factor(data_in$CEA_J,levels = c(0,1),labels = c("≤1.965ng/ml",">1.965ng/ml"))
data_in$Outcome<-factor(data_in$Outcome,levels = c(0,1),labels = c("Not HRPN","HRPN"))

data_out$Diameter_M<-factor(data_out$Diameter_M,levels = c(1,2,3),labels = c("5mm≤d≤10mm","10mm<d≤20mm","20mm<d≤30mm"))
data_out$CT.value_M<-factor(data_out$CT.value_M,levels = c(1,2,3,4),labels = c("-800HU<n≤-600HU","-600HU<n≤-400HU","-400HU<n≤-200HU","n≤-200HU"))
data_out$CTR_J<-factor(data_out$CTR_J,levels = c(0,1),labels = c("≤0.265",">0.265"))
data_out$CEA_J<-factor(data_out$CEA_J,levels = c(0,1),labels = c("≤1.965ng/ml",">1.965ng/ml"))
data_out$Outcome<-factor(data_out$Outcome,levels = c(0,1),labels = c("Not HRPN","HRPN"))


View(data)
summary(data)
str(data)

#数据打包
dd=datadist(data)
options(datadist="dd")

#校正曲线-1
formula1<-as.formula(Anastomotic_Leakage~BMI+Operation_Duration+Age+Preoperative_Albumin+Diabetes_Mellitus+COPD+Neoadjuvant_Therapy)
fit1 <-lrm(formula1,data=data,x=TRUE,y=TRUE)
cal1<-calibrate(fit1,method="boot",B=1000)

plot(cal1,
     xlim = c(0,1),
     xlab = "Nomogram Predicted Probability",
     ylab = "Actual Probability",
     legend = FALSE,
     subtitle = FALSE,)
abline(0,1,col="#000000",lty=2,lwd=2)
lines(cal1[,c("predy","calibrated.orig")],type = "l",lwd=2,col="#FF0000",pch=16)
lines(cal1[,c("predy","calibrated.corrected")],type = "l",lwd=2,col="#0082FF",pch=16)
legend(0.8,0.65,
       c("Ideal","apparent","Bias-corrected"),
       lty = c(2,1,1),
       lwd = c(2,1,1),
       col = c("#000000","#FF0000","#0082FF"),
       bty="n")


