##数据处理
#install.packages("rmda")
rm(list = ls())
library(rms)
library(readr)
library(rmda)
data <- read_csv("D:/R work/Model-TC.csv")
data_in <- read_csv("D:/R work/Model-IVC.csv")
data_out <- read_csv("D:/R work/Model-EVC.csv")

data$Diameter_M<-factor(data$Diameter_M,levels = c(1,2,3),labels = c("5mm≤d≤10mm","10mm<d≤20mm","20mm<d≤30mm"))
data$CT.value_M<-factor(data$CT.value_M,levels = c(1,2,3,4),labels = c("-800HU<n≤-600HU","-600HU<n≤-400HU","-400HU<n≤-200HU","n≤-200HU"))
data$CTR_J<-factor(data$CTR_J,levels = c(0,1),labels = c("≤0.265",">0.265"))
data$CEA_J<-factor(data$CEA_J,levels = c(0,1),labels = c("≤1.965ng/ml",">1.965ng/ml"))
data$Outcome<-factor(data$Outcome,levels = c(0,1),labels = c("Not HRPN","HRPN"))

data_in$Diameter_M<-factor(data_in$Diameter_M,levels = c(1,2,3),labels = c("5mm≤d≤10mm","10mm<d≤20mm","20mm<d≤30mm"))
data_in$CT.value_M<-factor(data_in$CT.value_M,levels = c(1,2,3,4),labels = c("-800HU<n≤-600HU","-600HU<n≤-400HU","-400HU<n≤-200HU","n≤-200HU"))
data_in$CTR_J<-factor(data_in$CTR_J,levels = c(0,1),labels = c("≤0.265",">0.265"))
data_in$CEA_J<-factor(data_in$CEA_J,levels = c(0,1),labels = c("≤1.965ng/ml",">1.965ng/ml"))
data_in$Outcome<-factor(data_in$Outcome,levels = c(0,1),labels = c("Not HRPN","HRPN"))

data_out$Diameter_M<-factor(data_out$Diameter_M,levels = c(1,2,3),labels = c("5mm≤d≤10mm","10mm<d≤20mm","20mm<d≤30mm"))
data_out$CT.value_M<-factor(data_out$CT.value_M,levels = c(1,2,3,4),labels = c("-800HU<n≤-600HU","-600HU<n≤-400HU","-400HU<n≤-200HU","n≤-200HU"))
data_out$CTR_J<-factor(data_out$CTR_J,levels = c(0,1),labels = c("≤0.265",">0.265"))
data_out$CEA_J<-factor(data_out$CEA_J,levels = c(0,1),labels = c("≤1.965ng/ml",">1.965ng/ml"))
data_out$Outcome<-factor(data_out$Outcome,levels = c(0,1),labels = c("Not HRPN","HRPN"))

View(data)
names(data)
summary(data)
str(data)

#模型
formula1<-as.formula(Outcome~Diameter_M+CT.value_M+CTR_J+CEA_J)
#DCA
model_1<-decision_curve(formula1,data=data,
                        family = binomial(link = 'logit'),
                        thresholds = seq(0,1,by=0.01),
                        confidence.intervals = 0.95,
                        study.design = 'cohort')
model_2<-decision_curve(formula1,data=data_in,
                        family = binomial(link = 'logit'),
                        thresholds = seq(0,1,by=0.01),
                        confidence.intervals = 0.95,
                        study.design = 'cohort')
model_3<-decision_curve(formula1,data=data_out,
                        family = binomial(link = 'logit'),
                        thresholds = seq(0,1,by=0.01),
                        confidence.intervals = 0.95,
                        study.design = 'cohort')
model_all<- list(model_1,model_2,model_3)
summary(model_1)
summary(model_2)
summary(model_3)

plot_decision_curve(model_all,curve.names = c('Training','Internal Validation','External Validation'),
                    xlim = c(0,1),
                    cost.benefit.axis = TRUE,col = c("#000000","#FF0000","#0082FF",),
                    confidence.intervals = FALSE,standardize = TRUE)
