##数据处理
rm(list = ls())
library(rms)
library(readr)
data <- read_csv("D:/R work/Model-TC.csv")
data_in <- read_csv("D:/R work/Model-IVC.csv")
data_out <- read_csv("D:/R work/Model-EVC.csv")

data$Diameter_M<-factor(data$Diameter_M,levels = c(1,2,3),labels = c("5mm≤d≤10mm","10mm<d≤20mm","20mm<d≤30mm"))
data$CT.value_M<-factor(data$CT.value_M,levels = c(1,2,3,4),labels = c("-800HU<n≤-600HU","-600HU<n≤-400HU","-400HU<n≤-200HU","n≤-200HU"))
data$CTR_J<-factor(data$CTR_J,levels = c(0,1),labels = c("≤0.265",">0.265"))
data$CEA_J<-factor(data$CEA_J,levels = c(0,1),labels = c("≤1.965ng/ml",">1.965ng/ml"))
data$Outcome<-factor(data$Outcome,levels = c(0,1),labels = c("Not HRPN","HRPN"))

data_in$Diameter_M<-factor(data_in$Diameter_M,levels = c(1,2,3),labels = c("5mm≤d≤10mm","10mm<d≤20mm","20mm<d≤30mm"))
data_in$CT.value_M<-factor(data_in$CT.value_M,levels = c(1,2,3,4),labels = c("-800HU<n≤-600HU","-600HU<n≤-400HU","-400HU<n≤-200HU","n≤-200HU"))
data_in$CTR_J<-factor(data_in$CTR_J,levels = c(0,1),labels = c("≤0.265",">0.265"))
data_in$CEA_J<-factor(data_in$CEA_J,levels = c(0,1),labels = c("≤1.965ng/ml",">1.965ng/ml"))
data_in$Outcome<-factor(data_in$Outcome,levels = c(0,1),labels = c("Not HRPN","HRPN"))

data_out$Diameter_M<-factor(data_out$Diameter_M,levels = c(1,2,3),labels = c("5mm≤d≤10mm","10mm<d≤20mm","20mm<d≤30mm"))
data_out$CT.value_M<-factor(data_out$CT.value_M,levels = c(1,2,3,4),labels = c("-800HU<n≤-600HU","-600HU<n≤-400HU","-400HU<n≤-200HU","n≤-200HU"))
data_out$CTR_J<-factor(data_out$CTR_J,levels = c(0,1),labels = c("≤0.265",">0.265"))
data_out$CEA_J<-factor(data_out$CEA_J,levels = c(0,1),labels = c("≤1.965ng/ml",">1.965ng/ml"))
data_out$Outcome<-factor(data_out$Outcome,levels = c(0,1),labels = c("Not HRPN","HRPN"))

View(data)
summary(data)
str(data)

#模型
formula1<-as.formula(Outcome~Diameter_M+CT.value_M+CTR_J+CEA_J)

#数据打包
dd=datadist(data)
options(datadist="dd")

dd_in=datadist(data_in)
options(datadist="dd_in")

dd_out=datadist(data_out)
options(datadist="dd_out")

#H-L检验
fit1<-glm(formula1,data=data,family = binomial(link = logit))
fit2<-glm(formula1,data=data_in,family = binomial(link = logit))
fit3<-glm(formula1,data=data_out,family = binomial(link = logit))
#install.packages("ResourceSelection")
library(ResourceSelection)
hl1 <-hoslem.test(fit1$y,fitted(fit1),g=10)
hl1
hl2 <-hoslem.test(fit2$y,fitted(fit2),g=10)
hl2
hl3 <-hoslem.test(fit3$y,fitted(fit3),g=10)
hl3
#X-squared = 8.1579, df = 8, p-value = 0.4182(卡方值8.1579，自由度为8，p值0.4182>0.05，拟合度好)