
#################################################################
#### 欢迎使用“医学列线图平台” 小程序在临床工作中使用列线图！ ####
#### 也欢迎大家关注“医学列线图”公众号                        ####
#### 我们经常推送各种列线图教程及优质的列线图研究文章！      ####
#### 欢迎关注，一起做图！                                    ####
#### 作者：马驰原教授团队、刘玉秀教授团队                    ####
#################################################################

#关于这些代码的使用方法，我们在公众号推出免费视频讲解课程，欢迎大家持续关注“医学列线图”公众号，相关信息和资源会在公众号中发布。
#我们还开发了“医学列线图”微信小程序，可以线上使用小程序收录的列线图。
#有任何问题欢迎联系nomogramhelp@126.com或公众号后台

#################################################################################
#### 以下代码完成一键对两组间数据进行组间差异的统计检验                      ####
#### 本套代码是在之前随机化分组并进行统计检验的基础上修改而成                ####
#### 1.连续型变量根据正态性和方差齐性选择t检验或Wilcox秩和检验               ####
#### 2.分类数据（包括二分类和多分类）根据数据情况选择卡方检验或fisher精确检验####
#### 3.生存数据用log rank检验                                                ####
#################################################################################

#################################################################################
#### 以下代码同时还完成一键对Group_A进行变量间交互作用的验证                 ####
#### 1.连续型变量根据均值重编码，大于均值时赋值为1，小于等于时赋值为0        ####
#################################################################################


#tips:1.所有的文件路径包括文件名尽量不要出现中文字符及空格。可以用下划线_代替空格区分单词。
#     2.报错里是warning没关系，还可以往下运行。如果是error就要停下来查看原因，一味往下运行是解决不了问题的。

################  0.环境准备及数据输入 ##########################

##0.0 安装需要的R包
#（第一次使用时才需要运行此部分代码。安装成功后不需要重复安装）
install.packages('car')
install.packages('survival')
install.packages('rms')
##0.1 调用R包
#清除R中的所有数据（归零）

rm(list = ls())
library(car)
library(survival)
library(rms)
#下方为预设函数，请直接运行加载
{#以下是从rms包中拷贝并修改的函数
  
  my_print_lrm<-function (x, digits = 4, strata.coefs = FALSE, coefs = TRUE, 
                          title = "Logistic Regression Model", ...) 
  {
    latex <- prType() == "latex"
    z <- list()
    k <- 0
    if (length(x$freq) > 3) {
      k <- k + 1
      z[[k]] <- list(type = "print", list(x$freq), title = "Frequencies of Responses")
    }
    if (length(x$sumwty)) {
      k <- k + 1
      z[[k]] <- list(type = "print", list(x$sumwty), 
                     title = "Sum of Weights by Response Category")
    }
    if (!is.null(x$nmiss)) {
      k <- k + 1
      z[[k]] <- list(type = "print", list(x$nmiss), title = "Frequencies of Missing Values Due to Each Variable")
    }
    else if (length(x$na.action)) {
      k <- k + 1
      z[[k]] <- list(type = paste("naprint", class(x$na.action), 
                                  sep = "."), list(x$na.action))
    }
    ns <- x$non.slopes
    nstrata <- x$nstrata
    if (!length(nstrata)) 
      nstrata <- 1
    pm <- x$penalty.matrix
    penaltyFactor <- NULL
    if (length(pm)) {
      psc <- if (length(pm) == 1) 
        sqrt(pm)
      else sqrt(diag(pm))
      penalty.scale <- c(rep(0, ns), psc)
      cof <- matrix(x$coef[-(1:ns)], ncol = 1)
      k <- k + 1
      z[[k]] <- list(type = "print", list(as.data.frame(x$penalty, 
                                                        row.names = "")), title = "Penalty factors")
      penaltyFactor <- as.vector(t(cof) %*% pm %*% cof)
    }
    est.exp <- 1:ns
    if (length(x$est)) 
      est.exp <- c(est.exp, ns + x$est[x$est + ns <= length(x$coefficients)])
    vv <- diag(x$var)
    cof <- x$coef
    if (strata.coefs) {
      cof <- c(cof, x$strata.coef)
      vv <- c(vv, vcov(x))
      if (length(pm)) 
        penalty.scale <- c(penalty.scale, rep(NA, x$nstrata - 
                                                1))
    }
    score.there <- nstrata == 1 && (length(x$est) < length(x$coef) - 
                                      ns)
    stats <- x$stats
    maxd <- stats["Max Deriv"]
    ci <- x$clusterInfo
    misc <- reListclean(Obs = stats["Obs"], `Sum of weights` = stats["Sum of Weights"], 
                        Strata = if (nstrata > 1) 
                          nstrata, `Cluster on` = ci$name, Clusters = ci$n, 
                        `max |deriv|` = maxd)
    if (length(x$freq) < 4) {
      names(x$freq) <- paste(if (latex) 
        "~~"
        else " ", names(x$freq), sep = "")
      misc <- c(misc[1], x$freq, misc[-1])
    }
    lr <- reListclean(`LR chi2` = stats["Model L.R."], 
                      d.f. = round(stats["d.f."], 3), `Pr(> chi2)` = stats["P"], 
                      Penalty = penaltyFactor)
    disc <- reListclean(R2 = stats["R2"], g = stats["g"], 
                        gr = stats["gr"], gp = stats["gp"], Brier = stats["Brier"])
    discr <- reListclean(C = stats["C"], Dxy = stats["Dxy"], 
                         gamma = stats["Gamma"], `tau-a` = stats["Tau-a"])
    headings <- c("", "Model Likelihood\nRatio Test", 
                  "Discrimination\nIndexes", "Rank Discrim.\nIndexes")
    data <- list(misc, c(lr, c(2, NA, -4, 2)), c(disc, 3), c(discr, 
                                                             3))
    k <- k + 1
    z[[k]] <- list(type = "stats", list(headings = headings, 
                                        data = data))
    if (coefs) {
      k <- k + 1
      z[[k]] <- list(type = "coefmatrix", list(coef = cof, 
                                               se = sqrt(vv), aux = if (length(pm)) penalty.scale, 
                                               auxname = "Penalty Scale"))
    }
    if (score.there) {
      q <- (1:length(cof))[-est.exp]
      if (length(q) == 1) 
        vv <- x$var[q, q]
      else vv <- diag(x$var[q, q])
      Z <- x$u[q]/sqrt(vv)
      stats <- cbind(format(Z, digits = 2), format(1 - pchisq(Z^2, 
                                                              1), digits = 4))
      dimnames(stats) <- list(names(cof[q]), c("Score Z", 
                                               "P"))
      k <- k + 1
      z[[k]] <- list(type = "print", list(stats))
    }
    my_U<-my_prModFit(x, title = title, z, digits = digits, coefs = coefs, 
                      ...)
    return(my_U)
  }
  
  #——————————————————————————————————————#
  my_print_cph<-function (x, digits = 4, table = TRUE, conf.int = FALSE, coefs = TRUE, 
                          title = "Cox Proportional Hazards Model", ...) 
  {
    k <- 0
    z <- list()
    if (length(zz <- x$na.action)) {
      k <- k + 1
      z[[k]] <- list(type = paste("naprint", class(zz)[1], 
                                  sep = "."), list(zz))
    }
    if (table && length(x$n) && is.matrix(x$n)) {
      k <- k + 1
      z[[k]] <- list(type = "print", list(x$n))
    }
    if (length(x$coef)) {
      stats <- x$stats
      ci <- x$clusterInfo
      misc <- reListclean(Obs = stats["Obs"], Events = stats["Events"], 
                          `Cluster on` = ci$name, Clusters = ci$n, Center = round(x$center, 
                                                                                  digits))
      lr <- reListclean(`LR chi2` = stats["Model L.R."], 
                        d.f. = stats["d.f."], `Pr(> chi2)` = stats["P"], 
                        `Score chi2` = stats["Score"], `Pr(> chi2)` = stats["Score P"])
      disc <- reListclean(R2 = stats["R2"], Dxy = stats["Dxy"], 
                          g = stats["g"], gr = stats["gr"])
      k <- k + 1
      headings <- c("", "Model Tests", "Discrimination\nIndexes")
      data <- list(misc, c(lr, c(2, NA, 4, 2, 4)), c(disc, 
                                                     3))
      z[[k]] <- list(type = "stats", list(headings = headings, 
                                          data = data))
      beta <- x$coef
      se <- sqrt(diag(x$var))
      k <- k + 1
      z[[k]] <- list(type = "coefmatrix", list(coef = x$coef, 
                                               se = sqrt(diag(x$var))))
      if (conf.int) {
        zcrit <- qnorm((1 + conf.int)/2)
        tmp <- cbind(exp(beta), exp(-beta), exp(beta - zcrit * 
                                                  se), exp(beta + zcrit * se))
        dimnames(tmp) <- list(names(beta), c("exp(coef)", 
                                             "exp(-coef)", paste("lower .", round(100 * 
                                                                                    conf.int, 2), sep = ""), paste("upper .", 
                                                                                                                   round(100 * conf.int, 2), sep = "")))
        k <- k + 1
        z[[k]] <- list(type = "print", list(tmp, digits = digits))
      }
    }
    my_U<-my_prModFit(x, title = title, z, digits = digits, coefs = coefs, 
                      ...)
    return(my_U)
  }
  #——————————————————————————————————————#  
  my_prModFit<-function (x, title, w, digits = 4, coefs = TRUE, footer = NULL, 
                         lines.page = 40, long = TRUE, needspace, subtitle = NULL, 
                         ...) 
  {
    lang <- prType()
    specs <- markupSpecs[[lang]]
    transl <- switch(lang, latex = latexTranslate, html = htmlTranslate, 
                     plain = function(x) x)
    nbsp <- htmlSpecial("nbsp")
    gt <- transl(">")
    vbar <- transl("|")
    chi2 <- specs$chisq()
    beta <- htmlGreek("beta")
    R <- character(0)
    bverb <- function() {
      switch(lang, html = "<pre>", latex = "\\begin{verbatim}", 
             plain = NULL)
    }
    everb <- function() switch(lang, html = "</pre>", latex = "\\end{verbatim}", 
                               plain = NULL)
    skipt <- function(n = 1) {
      if (n == 0) 
        return(character(0))
      if (n == 1) 
        return("")
      specs$lineskip(n)
    }
    catl <- function(x, skip = 1, bold = FALSE, verb = FALSE, 
                     pre = 0, center = FALSE, indent = FALSE) {
      if (lang == "latex") {
        if (verb) 
          c("\\begin{verbatim}", skipt(pre), x, skipt(skip), 
            "\\end{verbatim}")
        else c(skipt(pre), paste0(if (center) "\\centerline{" else if (!indent) "\\noindent ", 
                                  if (bold) "\\textbf{", x, if (bold) "}", if (center) "}"), 
               skipt(skip))
      }
      else if (lang == "html") {
        if (verb) 
          c("<pre>", skipt(pre), x, skipt(skip), "</pre>")
        else c(skipt(pre), paste0(if (center) "<div align=center>", 
                                  if (bold) "<strong>", x, if (bold) "</strong>", 
                                  if (center) "</div>"), skipt(skip))
      }
      else c(paste0(skipt(pre), x), skipt(skip))
    }
    latexVector <- function(x, ...) latexTabular(t(x), helvetica = FALSE, 
                                                 ...)
    if (length(x$fail) && x$fail) {
      return(catl("Model Did Not Converge.  No summary provided.", 
                  bold = TRUE, pre = 1, verb = TRUE))
    }
    R <- character(0)
    if (!missing(needspace) && lang == "latex") 
      R <- paste0("\\Needspace{", needspace, "}")
    lsub <- length(subtitle)
    if (title != "") 
      R <- c(R, catl(title, pre = 1, bold = TRUE, skip = if (lsub) 0 else 1))
    if (lsub) 
      for (i in lsub) R <- c(R, catl(subtitle[i], bold = FALSE))
    if (long) {
      R <- c(R, bverb(), deparse(x$call), everb(), "")
    }
    for (z in w) {
      type <- z$type
      obj <- z[[2]]
      titl <- z$title
      tex <- z$tex
      if (!length(tex)) 
        tex <- FALSE
      if (type == "naprint.delete") {
        if (lang == "latex") {
          type <- "latex.naprint.delete"
          tex <- TRUE
        }
        if (lang == "html") 
          type <- "html.naprint.delete"
      }
      preskip <- z$preskip
      if (!length(preskip)) 
        preskip <- 0
      if (!tex && length(titl)) 
        R <- c(R, "", catl(titl, pre = preskip, skip = 1))
      if (type == "stats") {
        R <- c(R, my_prStats(obj[[1]], obj[[2]], lang = lang))
      }
      else if (type == "coefmatrix") {
        if (coefs) {
          pad <- function(x) switch(lang, latex = paste0("~", 
                                                         x, "~"), html = paste0(nbsp, x), plain = x)
          betan <- switch(lang, plain = "Beta", html = htmlGreek("beta"), 
                          latex = "$\\hat{\\beta}$")
          B <- obj$bayes
          if (length(B)) {
            U <- matrix("", nrow = nrow(B), ncol = ncol(B))
            for (i in 1:ncol(B)) {
              dig <- if (colnames(B)[i] == "Symmetry") 
                2
              else digits
              U[, i] <- pad(formatNP(B[, i], dig, lang = lang))
            }
            pn <- switch(lang, plain = "Pr(Beta>0)", html = paste0("Pr(", 
                                                                   betan, transl(">"), "0)"), latex = "Pr$(\\beta>0)$")
            coltrans <- c(Mean = paste("Mean", betan), 
                          Median = paste("Median", betan), Mode = paste("Mode", 
                                                                        betan), SE = "S.E.", Lower = "Lower", 
                          Upper = "Upper", P = pn, Symmetry = "Symmetry")
            colnames(U) <- coltrans[colnames(B)]
            rownames(U) <- rownames(B)
            betanames <- rownames(B)
          }
          else {
            errordf <- obj$errordf
            beta <- obj$coef
            betanames <- names(beta)
            se <- obj$se
            Z <- beta/se
            P <- if (length(errordf)) 
              2 * (1 - pt(abs(Z), errordf))
            else 1 - pchisq(Z^2, 1)
            U <- cbind(Coef = pad(formatNP(beta, digits, 
                                           lang = lang)), S.E. = pad(formatNP(se, digits, 
                                                                              lang = lang)), `Wald Z` = formatNP(Z, 2, 
                                                                                                                 lang = lang), `Pr(>|Z|)` = formatNP(P, 4, 
                                                                                                                                                     lang = lang, pvalue = TRUE))
            
            if (lang == "latex") 
              colnames(U) <- c("$\\hat{\\beta}$", "S.E.", 
                               "Wald $Z$", "Pr$(>|Z|)$")
            else if (lang == "html") 
              colnames(U) <- c(htmlGreek("beta"), "S.E.", 
                               "Wald <i>Z</i>", paste0("Pr(", gt, vbar, 
                                                       "<i>Z</i>", vbar, ")"))
            if (length(errordf)) 
              colnames(U)[3:4] <- switch(lang, latex = c("$t$", 
                                                         "Pr$(>|t|)$"), html = c("<i>t</i>", paste0("Pr(", 
                                                                                                    gt, vbar, "<i>t</i>", vbar, ")")), plain = c("t", 
                                                                                                                                                 "Pr(>|t|)"))
            rownames(U) <- betanames
            #此处U包括了各参数p值，我仅增加了下面返回的一行
            return(U)
            if (length(obj$aux)) {
              U <- cbind(U, formatNP(obj$aux, digits, 
                                     lang = lang))
              colnames(U)[ncol(U)] <- obj$auxname
              
            }
          }
          if (lang %in% c("latex", "html")) {
            R <- c(R, skipt(1))
            rownames(U) <- transl(betanames)
            if (is.numeric(coefs)) {
              U <- U[1:coefs, , drop = FALSE]
              U <- rbind(U, rep("", ncol(U)))
              rownames(U)[nrow(U)] <- if (lang == "html") 
                "&hellip;"
              else "\\dots"
            }
            rownames(U) <- gsub("*", specs$times, rownames(U), 
                                fixed = TRUE)
            if (!missing(needspace) && lang == "latex") 
              R <- c(R, paste0("\\Needspace{", needspace, 
                               "}"))
            if (lang == "latex") 
              R <- c(R, capture.output(latex(U, file = "", 
                                             first.hline.double = FALSE, table = FALSE, 
                                             longtable = TRUE, lines.page = lines.page, 
                                             col.just = rep("r", ncol(U)), rowlabel = "", 
                                             already.math.col.names = TRUE, append = TRUE)))
            else {
              al <- paste(rep("r", ncol(U)), collapse = "")
              R <- c(R, as.character(htmlTable::htmlTable(U, 
                                                          css.cell = "min-width: 7em;", align = al, 
                                                          align.header = al, rowlabel = "", escape.html = FALSE)))
            }
          }
          else {
            if (is.numeric(coefs)) {
              U <- U[1:coefs, , drop = FALSE]
              U <- rbind(U, rep("", ncol(U)))
              rownames(U)[nrow(U)] <- ". . ."
            }
            R <- c(R, "", capture.output(print(U, quote = FALSE)), 
                   "")
          }
        }
      }
      else {
        if (tex) {
          R <- c(R, "\\begin{center}", if (length(titl)) c(titl, 
                                                           "\n"))
        }
        else {
          R <- c(R, skipt(preskip))
        }
        R <- c(R, if (type == "html.naprint.delete") do.call(type, 
                                                             obj) else if (type == "latex.naprint.delete") capture.output(do.call(type, 
                                                                                                                                  c(obj, list(file = "")))) else if (type == "print") c(bverb(), 
                                                                                                                                                                                        capture.output(do.call(type, obj)), everb()) else do.call(type, 
                                                                                                                                                                                                                                                  obj), if (tex) "\\end{center}" else "")
      }
    }
    if (length(footer)) 
      R <- c(R, paste0(specs$smallskip, transl(footer)))
    R <- paste0(R, "\n")
    switch(lang, html = htmltools::HTML(R), latex = cat(R), 
           plain = cat(R))
  }
  
  #——————————————————————————————————————#
  
  my_prStats<-function (labels, w, lang = c("plain", "latex", "html")) 
  {
    lang <- match.arg(lang)
    lorh <- lang != "plain"
    specs <- markupSpecs[[lang]]
    partial <- htmlSpecial("part")
    vbar <- htmlTranslate("|")
    cca <- htmlSpecial("combiningcircumflexaccent")
    beta <- htmlGreek("beta")
    geq <- htmlTranslate(">=")
    spaces <- function(n) if (n <= 0.5) 
      ""
    else substring("                                                         ", 
                   1, floor(n))
    ssplit <- function(x) {
      x <- strsplit(x, split = "\n")
      for (i in 1:length(x)) if (!length(x[[i]])) 
        x[[i]] <- ""
      x
    }
    trans <- switch(lang, latex = latexTranslate, html = htmlTranslate, 
                    plain = function(x) x)
    p <- length(labels)
    width <- numeric(p)
    for (i in 1:p) {
      labs <- ssplit(labels[i])[[1]]
      width[i] <- max(nchar(labs))
      u <- w[[i]]
      dig <- NA
      if (any(names(u) == "")) {
        dig <- unlist(u[names(u) == ""])
        u <- u[names(u) != ""]
      }
      lu <- length(u)
      dig <- rep(dig, length = lu)
      fu <- character(lu)
      for (j in 1:length(u)) {
        uj <- u[[j]]
        nuj <- names(u)[j]
        dg <- dig[j]
        fu[j] <- if (nuj == "Cluster on") 
          specs$code(trans(uj))
        else if (nuj == "max |deriv|") 
          formatNP(signif(uj, 1), lang = lang)
        else if (is.na(dg)) 
          format(uj)
        else if (dg < 0) 
          formatNP(uj, -dg, pvalue = TRUE, lang = lang)
        else formatNP(uj, dg, lang = lang)
      }
      names(fu) <- names(u)
      w[[i]] <- fu
      for (j in 1:length(u)) width[i] <- max(width[i], 1 + 
                                               nchar(nuj) + nchar(fu[j]))
    }
    if (lorh) {
      maxl <- max(sapply(w, length))
      z <- matrix("", nrow = maxl, ncol = p)
      fil <- if (lang == "latex") 
        "~\\hfill "
      else htmlSpecial("emsp")
      chisq <- specs$chisq()
      trans <- rbind(Dxy = c(latex = "$D_{xy}$", html = "<i>D</i><sub>xy</sub>"), 
                     `LR chi2` = c(latex = paste0("LR ", chisq), 
                                   html = paste0("LR ", chisq)), `Score chi2` = c(latex = paste0("Score ", 
                                                                                                 chisq), html = paste0("Score ", chisq)), 
                     `Pr(> chi2)` = c(latex = "Pr$(>\\chi^{2})$", 
                                      html = paste0("Pr(", htmlTranslate(">"), 
                                                    chisq, ")")), `tau-a` = c(latex = "$\\tau_{a}$", 
                                                                              html = paste0(htmlGreek("tau"), "<sub>a</sub>")), 
                     `sigma gamma` = c(latex = "$\\sigma_{\\gamma}$", 
                                       html = "&sigma;<sub>&gamma;</sub>"), `sigma w` = c(latex = "$\\sigma_{w}$", 
                                                                                          html = "&sigma;<sub>w</sub>"), gamma = c(latex = "$\\gamma$", 
                                                                                                                                   html = htmlGreek("gamma")), R2 = c(latex = "$R^{2}$", 
                                                                                                                                                                      html = "<i>R</i><sup>2</sup>"), `R2 adj` = c(latex = "$R^{2}_{\\textrm{adj}}$", 
                                                                                                                                                                                                                   html = paste0("<i>R</i>", specs$subsup("adj", 
                                                                                                                                                                                                                                                          "2"))), C = c(latex = "$C$", html = "<i>C</i>"), 
                     g = c(latex = "$g$", html = "<i>g</i>"), 
                     gp = c(latex = "$g_{p}$", html = "<i>g</i><sub>p</sub>"), 
                     gr = c(latex = "$g_{r}$", html = "<i>g</i><sub>r</sub>"), 
                     `max |deriv|` = c(latex = "$\\max|\\frac{\\partial\\log L}{\\partial \\beta}|$", 
                                       html = paste0("max ", vbar, partial, "log <i>L</i>/", 
                                                     partial, beta, vbar)), `mean |Y-Yhat|` = c(latex = "mean $|Y-\\hat{Y}|$", 
                                                                                                html = paste0("mean ", vbar, "<i>Y - Y</i>", 
                                                                                                              cca, vbar)), `Distinct Y` = c(latex = "Distinct $Y$", 
                                                                                                                                            html = "Distinct <i>Y</i>"), `Median Y` = c(latex = "$Y_{0.5}$", 
                                                                                                                                                                                        html = "<i>Y</i><sub>0.5</sub>"), `|Pr(Y>=median)-0.5|` = c(latex = "$|\\overline{\\mathrm{Pr}(Y\\geq Y_{0.5})-\\frac{1}{2}}|$", 
                                                                                                                                                                                                                                                    html = paste0("<span style=\"text-decoration: overline\">", 
                                                                                                                                                                                                                                                                  vbar, "Pr(<i>Y</i> ", geq, " median)-", 
                                                                                                                                                                                                                                                                  htmlSpecial("half"), vbar, "</span>")))
      for (i in 1:p) {
        k <- names(w[[i]])
        j <- k %in% rownames(trans)
        if (any(j)) 
          k[j] <- trans[k[j], lang]
        j <- !j
        if (any(j)) 
          k[j] <- switch(lang, plain = k[j], latex = latexTranslate(k[j], 
                                                                    greek = TRUE), html = htmlTranslate(k[j], greek = TRUE))
        z[1:length(k), i] <- paste0(k, fil, w[[i]])
      }
      al <- paste0("|", paste(rep("c|", p), collapse = ""))
      if (lang == "latex") 
        w <- latexTabular(z, headings = labels, align = al, 
                          halign = al, translate = FALSE, hline = 2, center = TRUE)
      else {
        labels <- gsub("\n", "<br>", labels)
        w <- htmlTable::htmlTable(z, header = labels, css.cell = "min-width: 9em;", 
                                  align = al, align.header = al, escape.html = FALSE)
        w <- htmltools::HTML(paste0(w, "\n"))
      }
      return(w)
    }
    z <- labs <- character(0)
    for (i in 1:p) {
      wid <- width[i]
      lab <- ssplit(labels[i])[[1]]
      for (j in 1:length(lab)) lab[j] <- paste0(spaces((wid - 
                                                          nchar(lab[j]))/2), lab[j])
      labs <- c(labs, paste(lab, collapse = "\n"))
      u <- w[[i]]
      a <- ""
      for (i in 1:length(u)) a <- paste0(a, names(u)[i], spaces(wid - 
                                                                  nchar(u[i]) - nchar(names(u[i]))), u[i], if (i < 
                                                                                                               length(u)) 
                                                                    "\n")
      z <- c(z, a)
    }
    res <- rbind(labs, z)
    rownames(res) <- NULL
    capture.output(print.char.matrix(res, vsep = "", hsep = "    ", 
                                     csep = "", top.border = FALSE, left.border = FALSE))
  }
}

##0.2 设置数据存放的文件夹目录
#注意文件夹路径的斜杠是双斜杠\\
data_dir <- choose.dir(default = "D:\\data_dir", caption = "选择数据存放的文件夹目录")


##0.3 设置导出文件的文件夹目录
#注意文件夹路径的斜杠是双斜杠\\
output_dir <- choose.dir(default = "D:\\output_dir", caption = "选择导出文件的文件夹目录")


##0.4 选择完整数据集数据文件（模板为logistic_all_dataset.txt或者cox_all_dataset.txt）

#本套代码使用的数据文件中，Group_A数据在上方，下面接Group_B数据

#根据logistic和cox分析使用的不同数据，请根据以下要求设置好导入的数据文件格式：
#对于logistic数据：
#数据文件格式要求：注意数据文件要保存为txt版本
#数据格式要求：1. 数据中不要有中文字符；
#              2. 数据中第一行为变量名；
#              3. 数据中第一列为预测结局二分类指标（结局指标必须设置为0/1形式）；
#              4. 数据中从第二列开始为其他变量；
#              5. 请保持Group_A和Group_B中相同变量的名称一致
#              6. 空值以NA填充；二分类变量以0/1表示；多分类变量进行哑变量处理后以0/1表示；
#模板为生成的仿真数据
#---------------------------------#
#对于cox数据：
#数据文件格式要求：注意数据文件要保存为txt版本
#数据格式要求：1. 数据中不要有中文字符；
#              2. 数据中第一行为变量名；
#              3. 数据中第一列和第二列为预测生存结局的时间和结局事件发生与否的指标（结局指标必须设置为0/1形式）（本套代码中必须以“OS”和"Censor"为结局事件变量名）；
#              4. 数据中从第三列开始为其他变量；
#              5. 请保持Group_A和Group_B中相同变量的名称一致
#              6. 空值以NA填充；二分类变量以0/1表示；多分类变量进行哑变量处理后以0/1表示；
#模板为生成的仿真数据

#此外，这套代码额外增加第二行类型注释行，用来注释对应每一列变量的类型。
#结局事件为“outcome”；连续型变量为“continuous_variable”；二分类型变量为“binary_variable”；
#此外，若有多分类变量，则第一个多分类变量下的所有哑变量类型均为“polytomous_variable_1”，第二个多分类变量下的所有哑变量类型均为“polytomous_variable_2”，有更多多分类变量则以此类推。

#选择文件路径
all_dataset_path <- choose.files(default = data_dir, caption = "请选数据集数据文件的txt文件。",
                                 multi = TRUE, filters = Filters,
                                 index = nrow(Filters))

#读取数据
all_dataset<- read.csv(all_dataset_path, header = TRUE,sep="\t", stringsAsFactors=FALSE)

#查看数据（一定要运行这一步）
if(TRUE){
  variables_label<-all_dataset[1,]
  clean_dataset<-apply(all_dataset[-1,],2, as.numeric)
  if(length(which(variables_label[1,]=="outcome"))==0){
    print("您尚未设置结局变量标签outcome,请参考模板数据进行设置后重新导入数据")
  }else if(length(which(variables_label[1,]=="outcome"))>0){
    #打印数据类型
    if(length(which(variables_label[1,]=="outcome"))==1){
      data_type<-"logistic_data_type"
      print(paste0("您的结局数据为 二分类 数据，需进行logistic回归分析"))
    }else if(length(which(variables_label[1,]=="outcome"))==2){
      data_type<-"cox_data_type"
      print(paste0("您的结局数据为 生存类型 数据，需进行cox回归分析"))
    }else if(length(which(variables_label[1,]=="outcome"))>2){
      print("您尚设置结局变量标签outcome超过2个,请参考模板数据进行设置后重新导入数据")
    }
    #打印总的样本数
    print(paste0("您的数据中共包含 ",dim(clean_dataset)[1]," 个样本"))
    #打印连续型变量数据情况
    if(length(which(variables_label[1,]=="continuous_variable"))==0){
      print(paste0("您数据中包含 0 个连续型变量"))
    }else if(length(which(variables_label[1,]=="continuous_variable"))>0){
      continuous_variable_names<-colnames(variables_label)[which(variables_label[1,]=="continuous_variable")]
      print(paste0("您数据中包含 ",length(continuous_variable_names)," 个连续型变量如下："))
      for (index_continuous_variable_names in 1:length(continuous_variable_names)) {
        print(paste0("   ",
                     continuous_variable_names[index_continuous_variable_names],
                     " 其中缺失值 ",
                     sum(is.na(clean_dataset[,continuous_variable_names[index_continuous_variable_names]])),
                     " 个 缺失值占比 ",
                     round((100*((sum(is.na(clean_dataset[,continuous_variable_names[index_continuous_variable_names]])))/(dim(clean_dataset)[1]))),2),
                     "%"))
      }
    }
    #打印二分类型变量数据情况
    if(length(which(variables_label[1,]=="binary_variable"))==0){
      print(paste0("您数据中包含 0 个二分类型变量"))
    }else if(length(which(variables_label[1,]=="binary_variable"))>0){
      binary_variable_names<-colnames(variables_label)[which(variables_label[1,]=="binary_variable")]
      print(paste0("您数据中包含 ",length(binary_variable_names)," 个二分类型变量如下："))
      for (index_binary_variable_names in 1:length(binary_variable_names)) {
        print(paste0("   ",
                     binary_variable_names[index_binary_variable_names],
                     " 其中缺失值 ",
                     sum(is.na(clean_dataset[,binary_variable_names[index_binary_variable_names]])),
                     " 个 缺失值占比 ",
                     round((100*((sum(is.na(clean_dataset[,binary_variable_names[index_binary_variable_names]])))/(dim(clean_dataset)[1]))),2),
                     "%"))
      }
    }
    #打印多分类型变量数据情况
    if(length(grep("polytomous_variable", variables_label[1,]))==0){
      print(paste0("您数据中包含 0 个多分类型变量"))
    }else if(length(grep("polytomous_variable", variables_label[1,]))>0){
      poly_names_table<-table(as.character(variables_label[1,grep("polytomous_variable", variables_label[1,])]))
      print(paste0("您数据中包含 ",length(poly_names_table)," 个多分类型变量如下："))
      for (index_polytomous_variable in 1:length(poly_names_table)) {
        print(paste0("其中第 ",index_polytomous_variable,"个多分类变量："))
        temp_index_polytomous_variable_label_name<-paste0("polytomous_variable_",index_polytomous_variable)
        for(index_polytomous_variable_detail in 1:length(which(variables_label[1,]==temp_index_polytomous_variable_label_name))){
          temp_index_polytomous_variable_name<-colnames(variables_label)[which(variables_label[1,]==temp_index_polytomous_variable_label_name)][index_polytomous_variable_detail]
          
          print(paste0("   ",
                       temp_index_polytomous_variable_name,
                       " 其中缺失值 ",
                       sum(is.na(clean_dataset[,temp_index_polytomous_variable_name])),
                       " 个 缺失值占比 ",
                       round((100*((sum(is.na(clean_dataset[,temp_index_polytomous_variable_name])))/(dim(clean_dataset)[1]))),2),
                       "%"))
          
        }
      }
    }
  }
}

##1.1设置Group_A(行数在前)和Group_B(行数在后)的例数
Group_A_number<-609
Group_B_number<-83

##1.2进行置Group_A和Group_B组间检验
{
  #划分训练集及验证集
  temp_trainging_dataset<-clean_dataset[c(1:Group_A_number),]
  temp_validation_dataset<-clean_dataset[c((Group_A_number+1):(Group_A_number+Group_B_number)),]
  ##1.3两组间变量比较
  #生成空的比较结果汇总表格
  printed_results_table<-data.frame(variables="variables",training_dataset="training_dataset",validation_dataset="validation_dataset",p_value="p_value",stringsAsFactors=FALSE)
  #比较outcome
  if("outcome" %in% names(table(as.character(variables_label)))){
    if(data_type=="logistic_data_type"){
      variable_names<-colnames(variables_label)[as.character(variables_label)=="outcome"]
      
      temp_training_data_columes<-temp_trainging_dataset[,variable_names]
      temp_validation_data_columes<-temp_validation_dataset[,variable_names]
      #生成空M
      M <- as.table(matrix(0,2,(length(variable_names)+1)))
      dimnames(M) <- list(datasets = c("training", "validation"),
                          classes = c("ref",variable_names))
      #计数并赋给M
      #整理training_data中的数据
      ##ref
      M["training","ref"]<-sum((temp_training_data_columes==0), na.rm = T)
      ##other classes
      for (index_classes in 2:dim(M)[2]) {
        M["training",colnames(M)[index_classes]]<-sum(temp_training_data_columes==1, na.rm = T)
      }
      #整理validation_data中的数据
      ##ref
      M["validation","ref"]<-sum((temp_validation_data_columes==0), na.rm = T)
      ##other classes
      for (index_classes in 2:dim(M)[2]) {
        M["validation",colnames(M)[index_classes]]<-sum(temp_validation_data_columes==1, na.rm = T)
      }
      #计算结果
      col_matrix_ratio_producer<-function(M, round_num){
        out_table<-M
        for(index_row in 1:nrow(M)){
          sum_row<-sum(M[index_row,])
          for(index_col in 1:ncol(M)){
            ratio<-round(100*M[index_row,index_col]/sum_row, round_num)
            out_table[index_row,index_col]<-paste0(M[index_row,index_col], " (",ratio,"%)")
          }
        }
        return(out_table)
      }
      chisqcp<-chisq.test(M)[3][[1]]
      fisherp<- tryCatch(fisher.test(M)[1][[1]],error=function(e){return("A")} )
      if(fisherp=="A"){           # 判断当前循环的try语句中的表达式是否运行正确
        fisherp<-fisher.test(M,simulate.p.value=TRUE)[1][[1]]
        # 此处可以对运行错误的情况进行处理应对
      }
      col_matrix_observed<-chisq.test(M)$observed
      col_matrix_expected<-chisq.test(M)$expected
      round_num<-1
      col_matrix_ratio<-col_matrix_ratio_producer(M, round_num)
      ##总的观察数
      sum_N<-sum(M)
      #评估应该选择的是卡方检验还是fisher检验的结果
      if(any(col_matrix_expected<5) | sum_N<40){
        finalp<-fisherp
      }else{
        finalp<-chisqcp
      }
      
      #增加结果到输出的表格中
      temp_printed_results_table<-data.frame(variables=c("ref",variable_names),training_dataset=col_matrix_ratio["training",],validation_dataset=col_matrix_ratio["validation",],p_value=c(finalp,"NA"),stringsAsFactors=FALSE)
      printed_results_table<-rbind(printed_results_table,temp_printed_results_table)
      
    }else if(data_type=="cox_data_type"){
      #生成sur计算需要的表格
      temp_sur_training_table<-temp_trainging_dataset[,c("OS","Censor","Censor")]
      colnames(temp_sur_training_table)[3]<-"grp"
      temp_sur_training_table[,3]<-0
      temp_sur_validation_table<-temp_validation_dataset[,c("OS","Censor","Censor")]
      colnames(temp_sur_validation_table)[3]<-"grp"
      temp_sur_validation_table[,3]<-1
      temp_sur_table<-rbind(temp_sur_training_table,temp_sur_validation_table)
      temp_sur_table<-as.data.frame(temp_sur_table)
      #logrank检验
      sur_comp<-survdiff(Surv(OS, Censor) ~ grp,
                         data = temp_sur_table)#默认log rank检验
      
      #增加结果到输出的表格中
      temp_printed_results_table<-data.frame(variables="Survival",training_dataset="NA",validation_dataset="NA",p_value=sur_comp$chisq,stringsAsFactors=FALSE)
      printed_results_table<-rbind(printed_results_table,temp_printed_results_table)
    }
  }
  #比较连续型变量
  if("continuous_variable" %in% names(table(as.character(variables_label)))){
    all_continuous_variable_names<-colnames(variables_label)[as.character(variables_label)=="continuous_variable"]
    for (index_all_continuous_variable_names in 1:length(all_continuous_variable_names)) {
      variable_names<-all_continuous_variable_names[index_all_continuous_variable_names]
      print(variable_names)
      temp_training_data_columes<-temp_trainging_dataset[,variable_names]
      temp_validation_data_columes<-temp_validation_dataset[,variable_names]
      #去掉NA
      temp_training_data_columes<-temp_training_data_columes[!is.na(temp_training_data_columes)]
      temp_validation_data_columes<-temp_validation_data_columes[!is.na(temp_validation_data_columes)]
      judge_p<-function(p1,p2,p3,tp,zhp){
        mark<-0
        if(p1<0.05){
          mark<-1
        }
        if(p2<0.05){
          mark<-1
        }
        if(p3<0.05){
          mark<-1
        }
        if(mark==0){
          return(tp)
        }else{
          return(zhp)
        }
      }
      grp_1_ztp<-shapiro.test(temp_training_data_columes)[2][[1]]
      grp_2_ztp<-shapiro.test(temp_validation_data_columes)[2][[1]]
      y_leveneT=c(temp_training_data_columes, temp_validation_data_columes)
      group_leveneT=as.factor(c(rep(1,length(temp_training_data_columes)), rep(2,length(temp_validation_data_columes))))
      fcp<-leveneTest(y_leveneT,group_leveneT)[3][[1]][1]
      t_testp<-t.test(temp_training_data_columes,temp_validation_data_columes,paired=F)[3][[1]]
      df = data.frame(y_leveneT,group_leveneT)
      zhp<-wilcox.test(y_leveneT~group_leveneT, df)[3][[1]]
      finalp<-judge_p(p1=grp_1_ztp, p2=grp_2_ztp, p3=fcp, tp=t_testp, zhp=zhp)
      #增加结果到输出的表格中
      temp_training_label<-paste0(round(mean(temp_training_data_columes),2)," ± ",round(sd(temp_training_data_columes),2))
      temp_validation_label<-paste0(round(mean(temp_validation_data_columes),2)," ± ",round(sd(temp_validation_data_columes),2))
      
      temp_printed_results_table<-data.frame(variables=variable_names,training_dataset=temp_training_label,validation_dataset=temp_validation_label,p_value=finalp,stringsAsFactors=FALSE)
      printed_results_table<-rbind(printed_results_table,temp_printed_results_table)
      
    }
  }
  #比较二分类型变量
  if("binary_variable" %in% names(table(as.character(variables_label)))){
    all_binary_variable_names<-colnames(variables_label)[as.character(variables_label)=="binary_variable"]
    for (index_all_binary_variable_names in 1:length(all_binary_variable_names)) {
      variable_names<-all_binary_variable_names[index_all_binary_variable_names]
      
      temp_training_data_columes<-temp_trainging_dataset[,variable_names]
      temp_validation_data_columes<-temp_validation_dataset[,variable_names]
      #生成空M
      M <- as.table(matrix(0,2,(length(variable_names)+1)))
      dimnames(M) <- list(datasets = c("training", "validation"),
                          classes = c("ref",variable_names))
      #计数并赋给M
      #整理training_data中的数据
      ##ref
      M["training","ref"]<-sum((temp_training_data_columes==0), na.rm = T)
      ##other classes
      for (index_classes in 2:dim(M)[2]) {
        M["training",colnames(M)[index_classes]]<-sum(temp_training_data_columes==1, na.rm = T)
      }
      #整理validation_data中的数据
      ##ref
      M["validation","ref"]<-sum((temp_validation_data_columes==0), na.rm = T)
      ##other classes
      for (index_classes in 2:dim(M)[2]) {
        M["validation",colnames(M)[index_classes]]<-sum(temp_validation_data_columes==1, na.rm = T)
      }
      #计算结果
      col_matrix_ratio_producer<-function(M, round_num){
        out_table<-M
        for(index_row in 1:nrow(M)){
          sum_row<-sum(M[index_row,])
          for(index_col in 1:ncol(M)){
            ratio<-round(100*M[index_row,index_col]/sum_row, round_num)
            out_table[index_row,index_col]<-paste0(M[index_row,index_col], " (",ratio,"%)")
          }
        }
        return(out_table)
      }
      chisqcp<-chisq.test(M)[3][[1]]
      fisherp<- tryCatch(fisher.test(M)[1][[1]],error=function(e){return("A")} )
      if(fisherp=="A"){           # 判断当前循环的try语句中的表达式是否运行正确
        fisherp<-fisher.test(M,simulate.p.value=TRUE)[1][[1]]
        # 此处可以对运行错误的情况进行处理应对
      }
      col_matrix_observed<-chisq.test(M)$observed
      col_matrix_expected<-chisq.test(M)$expected
      round_num<-1
      col_matrix_ratio<-col_matrix_ratio_producer(M, round_num)
      ##总的观察数
      sum_N<-sum(M)
      #评估应该选择的是卡方检验还是fisher检验的结果
      if(any(col_matrix_expected<5) | sum_N<40){
        finalp<-fisherp
      }else{
        finalp<-chisqcp
      }
      
      #增加结果到输出的表格中
      temp_printed_results_table<-data.frame(variables=c("ref",variable_names),training_dataset=col_matrix_ratio["training",],validation_dataset=col_matrix_ratio["validation",],p_value=c(finalp,"NA"),stringsAsFactors=FALSE)
      printed_results_table<-rbind(printed_results_table,temp_printed_results_table)
      
    }
  }
  #比较多分类型变量
  if(length(grep("polytomous_variable", names(table(as.character(variables_label)))))>0){
    for(index_polytomous_variable in 1:length(grep("polytomous_variable", names(table(as.character(variables_label)))))){
      polytomous_variable_names<-paste0("polytomous_variable_",index_polytomous_variable)
      variable_names<-colnames(variables_label)[variables_label[1,]==polytomous_variable_names]
      
      temp_training_data_columes<-temp_trainging_dataset[,variable_names]
      temp_validation_data_columes<-temp_validation_dataset[,variable_names]
      #生成空M
      M <- as.table(matrix(0,2,(length(variable_names)+1)))
      dimnames(M) <- list(datasets = c("training", "validation"),
                          classes = c("ref",variable_names))
      
      #计数并赋给M
      #整理training_data中的数据
      ##ref
      M["training","ref"]<-sum(apply(temp_training_data_columes,1,function(vec){all(vec==0)}), na.rm = T)
      ##other classes
      for (index_classes in 2:dim(M)[2]) {
        M["training",colnames(M)[index_classes]]<-sum(temp_training_data_columes[,colnames(M)[index_classes]], na.rm = T)
      }
      #整理validation_data中的数据
      ##ref
      M["validation","ref"]<-sum(apply(temp_validation_data_columes,1,function(vec){all(vec==0)}), na.rm = T)
      ##other classes
      for (index_classes in 2:dim(M)[2]) {
        M["validation",colnames(M)[index_classes]]<-sum(temp_validation_data_columes[,colnames(M)[index_classes]], na.rm = T)
      }
      #计算结果
      col_matrix_ratio_producer<-function(M, round_num){
        out_table<-M
        for(index_row in 1:nrow(M)){
          sum_row<-sum(M[index_row,])
          for(index_col in 1:ncol(M)){
            ratio<-round(100*M[index_row,index_col]/sum_row, round_num)
            out_table[index_row,index_col]<-paste0(M[index_row,index_col], " (",ratio,"%)")
          }
        }
        return(out_table)
      }
      chisqcp<-chisq.test(M)[3][[1]]
      fisherp<- tryCatch(fisher.test(M)[1][[1]],error=function(e){return("A")} )
      if(fisherp=="A"){           # 判断当前循环的try语句中的表达式是否运行正确
        fisherp<-fisher.test(M,simulate.p.value=TRUE)[1][[1]]
        # 此处可以对运行错误的情况进行处理应对
      }
      col_matrix_observed<-chisq.test(M)$observed
      col_matrix_expected<-chisq.test(M)$expected
      round_num<-1
      col_matrix_ratio<-col_matrix_ratio_producer(M, round_num)
      ##总的观察数
      sum_N<-sum(M)
      #评估应该选择的是卡方检验还是fisher检验的结果
      if(any(col_matrix_expected<5) | sum_N<40){
        finalp<-fisherp
      }else{
        finalp<-chisqcp
      }
      
      #增加结果到输出的表格中
      temp_printed_results_table<-data.frame(variables=c("ref",variable_names),training_dataset=col_matrix_ratio["training",],validation_dataset=col_matrix_ratio["validation",],p_value=c(finalp,rep("NA",(dim(col_matrix_ratio)[2]-1))),stringsAsFactors=FALSE)
      printed_results_table<-rbind(printed_results_table,temp_printed_results_table)
    }
  }
  #去掉空的第一行
  printed_results_table<-printed_results_table[-1,]
  #计算小于0.05的p值个数
  all_p_value<-as.numeric(printed_results_table$p_value)
  all_p_value<-sum(all_p_value<=0.05,na.rm = TRUE)
  #改名printed_results_table
  colnames(printed_results_table)[2]<-"Group_A"
  colnames(printed_results_table)[3]<-"Group_B"
}
##1.3Group_A内部变量间交互作用的检验
{if(any(grepl("continuous_variable",variables_label))){#检查是否有连续型变量
  #1.4.1按均值对连续型变量重编码为二分类变量的部分
  Cmean_temp_trainging_dataset<-temp_trainging_dataset
  Cmean_variables_label<-variables_label
  continuous_position<-grep("continuous_variable",variables_label)
  #重编码，大于cut_off_value值时赋值为1，小于等于时赋值为0
  for (index_continuous in length(continuous_position):1) {
    cut_off_value<-mean(Cmean_temp_trainging_dataset[,(continuous_position[index_continuous])],na.rm = TRUE)
    for (index_recode_row in 1:nrow(Cmean_temp_trainging_dataset)) {
      if(!is.na(Cmean_temp_trainging_dataset[index_recode_row,continuous_position[index_continuous]][[1]])){
        if(Cmean_temp_trainging_dataset[index_recode_row,continuous_position[index_continuous]][[1]]>cut_off_value){
          Cmean_temp_trainging_dataset[index_recode_row,continuous_position[index_continuous]][[1]]<-1
        }else{
          Cmean_temp_trainging_dataset[index_recode_row,continuous_position[index_continuous]][[1]]<-0
        }
      }
    }
    Cmean_variables_label[1,(continuous_position[index_continuous])]<-"binary_variable"
  }
  #将"binary_variable"标签重编为“"binary_variable_n"标签
  if(any(grepl("binary_variable",Cmean_variables_label))){
    binary_position<-grep("binary_variable",Cmean_variables_label)
    for (index_binary in 1:length(binary_position)) {
      Cmean_variables_label[1,binary_position[index_binary]]<-paste0("binary_variable_",index_binary)
    }
  }
  #计算变量间交互作用，并保存
  #生成空的保存表格
  if(data_type=="logistic_data_type"){
    variables_num<-ncol(variables_label)-1
    variables_names<-colnames(variables_label)[2:ncol(variables_label)]
  }else if(data_type=="cox_data_type"){
    variables_num<-ncol(variables_label)-2
    variables_names<-colnames(variables_label)[3:ncol(variables_label)]
  }
  Cmean_report_table<-as.data.frame(matrix(data=NA, nrow = variables_num, ncol = variables_num, byrow = FALSE, dimnames = list(c(variables_names),c(variables_names))))
  #计算交互作用
  variables_label_list<-names(table(as.character(Cmean_variables_label)))
  variables_label_list<-variables_label_list[variables_label_list!="outcome"]
  for (index_A in 1:(length(variables_label_list)-1)) {
    for(index_B in(index_A+1):length(variables_label_list)){
      
      variable_A_label<-variables_label_list[index_A]
      variable_B_label<-variables_label_list[index_B]
      variable_type_judge<-function(variable_A_label){
        output<-0
        if(length(grep("binary_variable",variable_A_label))!=0){
          output<-"binary_variable"
        }else if(length(grep("polytomous_variable",variable_A_label))!=0){
          output<-"polytomous_variable"
        }
        return(output)
      }
      variable_A_type<-variable_type_judge(variable_A_label)
      variable_B_type<-variable_type_judge(variable_B_label)
      variable_A_list<-names(Cmean_variables_label)[Cmean_variables_label==variable_A_label]
      variable_B_list<-names(Cmean_variables_label)[Cmean_variables_label==variable_B_label]
      variable_outcome_list<-names(Cmean_variables_label)[Cmean_variables_label=="outcome"]
      #生成formula
      if(data_type=="logistic_data_type"){
        f <-paste0(variable_outcome_list," ~ ")
      }else if(data_type=="cox_data_type"){
        f <-paste0("Surv(OS,Censor)"," ~ ")
      }
      f <-paste0(f,paste(c(variable_A_list), collapse = "+"))
      f <-paste0(f,"+",paste(c(variable_B_list), collapse = "+"))
      for (index_variable_A_list in 1:length(variable_A_list)) {
        for (index_variable_B_list in 1:length(variable_B_list)) {
          f <-paste0(f,"+",variable_A_list[index_variable_A_list],"*",variable_B_list[index_variable_B_list])
        }
      }
      f <-as.formula(f)
      #回归分析
      Cmean_temp_trainging_dataset<-as.data.frame(Cmean_temp_trainging_dataset)
      ddist <- datadist(Cmean_temp_trainging_dataset)
      options(datadist='ddist')
      if(data_type=="logistic_data_type"){
        f_reg <- tryCatch(lrm(f, data=Cmean_temp_trainging_dataset, x=TRUE, y=TRUE,maxit=1000),error=function(e){return(list(fail=TRUE))} )
        if(f_reg$fail | 'try-error' %in% class(f_reg)){           # 判断当前循环的try语句中的表达式是否运行正确
          # 若该回归分析无法进行则不对Cmean_report_table进行赋值
        }else{
          my_U<-my_print_lrm(f_reg)
          #提取p值
          for (index_variable_A_list in 1:length(variable_A_list)) {
            for (index_variable_B_list in 1:length(variable_B_list)) {
              cross_name<-paste0(variable_A_list[index_variable_A_list]," * ",variable_B_list[index_variable_B_list])
              if(cross_name %in% rownames(my_U)){
                Cmean_report_table[variable_A_list[index_variable_A_list],variable_B_list[index_variable_B_list]]<-my_U[cross_name,"Pr(>|Z|)"]
              }
            }
          }
        }
      }else if(data_type=="cox_data_type"){
        f_reg <- tryCatch(cph(f,x=T, y=T, surv=T,data=Cmean_temp_trainging_dataset,se.fit=TRUE),error=function(e){return(list(fail=TRUE))} )
        if(f_reg$fail | 'try-error' %in% class(f_reg)){           # 判断当前循环的try语句中的表达式是否运行正确
          # 若该回归分析无法进行则不对Cmean_report_table进行赋值
        }else{
          my_U<-my_print_cph(f_reg)
          #提取p值
          for (index_variable_A_list in 1:length(variable_A_list)) {
            for (index_variable_B_list in 1:length(variable_B_list)) {
              cross_name<-paste0(variable_A_list[index_variable_A_list]," * ",variable_B_list[index_variable_B_list])
              if(cross_name %in% rownames(my_U)){
                Cmean_report_table[variable_A_list[index_variable_A_list],variable_B_list[index_variable_B_list]]<-my_U[cross_name,"Pr(>|Z|)"]
              }
            }
          }
        }
      }
    }
  }
}else{#无连续型变量
  Cmean_temp_trainging_dataset<-temp_trainging_dataset
  Cmean_variables_label<-variables_label
  #将"binary_variable"标签重编为“"binary_variable_n"标签
  if(any(grepl("binary_variable",Cmean_variables_label))){
    binary_position<-grep("binary_variable",Cmean_variables_label)
    for (index_binary in 1:length(binary_position)) {
      Cmean_variables_label[1,binary_position[index_binary]]<-paste0("binary_variable_",index_binary)
    }
  }
  #计算变量间交互作用，并保存
  #生成空的保存表格
  if(data_type=="logistic_data_type"){
    variables_num<-ncol(variables_label)-1
    variables_names<-colnames(variables_label)[2:ncol(variables_label)]
  }else if(data_type=="cox_data_type"){
    variables_num<-ncol(variables_label)-2
    variables_names<-colnames(variables_label)[3:ncol(variables_label)]
  }
  Cmean_report_table<-as.data.frame(matrix(data=NA, nrow = variables_num, ncol = variables_num, byrow = FALSE, dimnames = list(c(variables_names),c(variables_names))))
  #计算交互作用
  variables_label_list<-names(table(as.character(Cmean_variables_label)))
  variables_label_list<-variables_label_list[variables_label_list!="outcome"]
  for (index_A in 1:(length(variables_label_list)-1)) {
    for(index_B in(index_A+1):length(variables_label_list)){
      
      variable_A_label<-variables_label_list[index_A]
      variable_B_label<-variables_label_list[index_B]
      variable_type_judge<-function(variable_A_label){
        output<-0
        if(length(grep("binary_variable",variable_A_label))!=0){
          output<-"binary_variable"
        }else if(length(grep("polytomous_variable",variable_A_label))!=0){
          output<-"polytomous_variable"
        }
        return(output)
      }
      variable_A_type<-variable_type_judge(variable_A_label)
      variable_B_type<-variable_type_judge(variable_B_label)
      variable_A_list<-names(Cmean_variables_label)[Cmean_variables_label==variable_A_label]
      variable_B_list<-names(Cmean_variables_label)[Cmean_variables_label==variable_B_label]
      variable_outcome_list<-names(Cmean_variables_label)[Cmean_variables_label=="outcome"]
      #生成formula
      if(data_type=="logistic_data_type"){
        f <-paste0(variable_outcome_list," ~ ")
      }else if(data_type=="cox_data_type"){
        f <-paste0("Surv(OS,Censor)"," ~ ")
      }
      f <-paste0(f,paste(c(variable_A_list), collapse = "+"))
      f <-paste0(f,"+",paste(c(variable_B_list), collapse = "+"))
      for (index_variable_A_list in 1:length(variable_A_list)) {
        for (index_variable_B_list in 1:length(variable_B_list)) {
          f <-paste0(f,"+",variable_A_list[index_variable_A_list],"*",variable_B_list[index_variable_B_list])
        }
      }
      f <-as.formula(f)
      #回归分析
      Cmean_temp_trainging_dataset<-as.data.frame(Cmean_temp_trainging_dataset)
      ddist <- datadist(Cmean_temp_trainging_dataset)
      options(datadist='ddist')
      if(data_type=="logistic_data_type"){
        f_reg <- tryCatch(lrm(f, data=Cmean_temp_trainging_dataset, x=TRUE, y=TRUE,maxit=1000),error=function(e){return(list(fail=TRUE))} )
        if(f_reg$fail | 'try-error' %in% class(f_reg)){           # 判断当前循环的try语句中的表达式是否运行正确
          # 若该回归分析无法进行则不对Cmean_report_table进行赋值
        }else{
          my_U<-my_print_lrm(f_reg)
          #提取p值
          for (index_variable_A_list in 1:length(variable_A_list)) {
            for (index_variable_B_list in 1:length(variable_B_list)) {
              cross_name<-paste0(variable_A_list[index_variable_A_list]," * ",variable_B_list[index_variable_B_list])
              if(cross_name %in% rownames(my_U)){
                Cmean_report_table[variable_A_list[index_variable_A_list],variable_B_list[index_variable_B_list]]<-my_U[cross_name,"Pr(>|Z|)"]
              }
            }
          }
        }
      }else if(data_type=="cox_data_type"){
        f_reg <- tryCatch(cph(f,x=T, y=T, surv=T,data=Cmean_temp_trainging_dataset,se.fit=TRUE),error=function(e){return(list(fail=TRUE))} )
        if(f_reg$fail | 'try-error' %in% class(f_reg)){           # 判断当前循环的try语句中的表达式是否运行正确
          # 若该回归分析无法进行则不对Cmean_report_table进行赋值
        }else{
          my_U<-my_print_cph(f_reg)
          #提取p值
          for (index_variable_A_list in 1:length(variable_A_list)) {
            for (index_variable_B_list in 1:length(variable_B_list)) {
              cross_name<-paste0(variable_A_list[index_variable_A_list]," * ",variable_B_list[index_variable_B_list])
              if(cross_name %in% rownames(my_U)){
                Cmean_report_table[variable_A_list[index_variable_A_list],variable_B_list[index_variable_B_list]]<-my_U[cross_name,"Pr(>|Z|)"]
              }
            }
          }
        }
      }
    }
  }
}}
######
##1.4打印报告
{print("该次Group_A及Group_B间比较如下：")
  print(paste0("其中，有 ",all_p_value," 个变量存在组间差异（p值<=0.05）"))
  print(printed_results_table)}
{print("Group_A中交互作用比较p值如下：（连续型变量按均值重编码为二分类变量）")
  print("p小于0.05提示该处横坐标和纵坐标变量之间可能存在交互作用")
  print(Cmean_report_table)
}
##1.5导出Group_A及Group_B集数据及数据集间比较结果
#如要导出Group_A及Group_B数据及数据集间比较结果，请运行下面一行代码。
write.table(temp_trainging_dataset,file = paste0(output_dir, "\\", "Group_A_dataset.txt"), row.names = FALSE,sep = "\t")
write.table(temp_validation_dataset,file = paste0(output_dir, "\\", "Group_B_dataset.txt"), row.names = FALSE,sep = "\t")
write.table(printed_results_table,file = paste0(output_dir, "\\", "groups_comparison_result.txt"), row.names = FALSE,sep = "\t")

##1.6导出Group_A中交互作用分析时重编码后的数据集
write.table(Cmean_temp_trainging_dataset,file = paste0(output_dir, "\\", "Cmean_Group_A_dataset.txt"), row.names = FALSE,sep = "\t")
write.table(Cmean_report_table,file = paste0(output_dir, "\\", "Cmean_Group_A_report_table.txt"), row.names = TRUE,col.names=NA,sep = "\t")


